//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCameras_h
#define PCameras_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CaptureCapability|
//
namespace mozilla {
namespace camera {
class CaptureCapability final
{
private:

public:
    MOZ_IMPLICIT CaptureCapability();

    MOZ_IMPLICIT CaptureCapability(
            const int& _width,
            const int& _height,
            const int& _maxFPS,
            const int& _expectedCaptureDelay,
            const int& _rawType,
            const int& _codecType,
            const bool& _interlaced)
    {
        Init();
        Assign(_width, _height, _maxFPS, _expectedCaptureDelay, _rawType, _codecType, _interlaced);
    }

    MOZ_IMPLICIT CaptureCapability(const CaptureCapability& _o)
    {
        Init();
        Assign((_o).width(), (_o).height(), (_o).maxFPS(), (_o).expectedCaptureDelay(), (_o).rawType(), (_o).codecType(), (_o).interlaced());
    }

    ~CaptureCapability();

    void
    operator=(const CaptureCapability& _o)
    {
        Assign((_o).width(), (_o).height(), (_o).maxFPS(), (_o).expectedCaptureDelay(), (_o).rawType(), (_o).codecType(), (_o).interlaced());
    }

    bool
    operator==(const CaptureCapability& _o) const;

    int&
    width()
    {
        return width_;
    }
    const int&
    width() const
    {
        return width_;
    }

    int&
    height()
    {
        return height_;
    }
    const int&
    height() const
    {
        return height_;
    }

    int&
    maxFPS()
    {
        return maxFPS_;
    }
    const int&
    maxFPS() const
    {
        return maxFPS_;
    }

    int&
    expectedCaptureDelay()
    {
        return expectedCaptureDelay_;
    }
    const int&
    expectedCaptureDelay() const
    {
        return expectedCaptureDelay_;
    }

    int&
    rawType()
    {
        return rawType_;
    }
    const int&
    rawType() const
    {
        return rawType_;
    }

    int&
    codecType()
    {
        return codecType_;
    }
    const int&
    codecType() const
    {
        return codecType_;
    }

    bool&
    interlaced()
    {
        return interlaced_;
    }
    const bool&
    interlaced() const
    {
        return interlaced_;
    }

private:
    void
    Init();

    void
    Assign(
            const int& _width,
            const int& _height,
            const int& _maxFPS,
            const int& _expectedCaptureDelay,
            const int& _rawType,
            const int& _codecType,
            const bool& _interlaced);

    int width_;
    int height_;
    int maxFPS_;
    int expectedCaptureDelay_;
    int rawType_;
    int codecType_;
    bool interlaced_;
};
} // namespace camera
} // namespace mozilla

namespace mozilla {
namespace camera {
class PCamerasParent;
} // namespace camera
} // namespace mozilla
namespace mozilla {
namespace camera {
class PCamerasChild;
} // namespace camera
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PCamerasChild and PCamerasParent
//
namespace mozilla {
namespace camera {
namespace PCameras {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::camera::PCamerasParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::camera::PCamerasChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PCamerasStart = PCamerasMsgStart << 16,
    Msg_FrameSizeChange__ID,
    Msg_DeliverFrame__ID,
    Msg_DeviceChange__ID,
    Msg_ReplyNumberOfCaptureDevices__ID,
    Msg_ReplyNumberOfCapabilities__ID,
    Msg_ReplyAllocateCaptureDevice__ID,
    Msg_ReplyGetCaptureCapability__ID,
    Msg_ReplyGetCaptureDevice__ID,
    Msg_ReplyFailure__ID,
    Msg_ReplySuccess__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_NumberOfCaptureDevices__ID,
    Msg_NumberOfCapabilities__ID,
    Msg_GetCaptureCapability__ID,
    Msg_GetCaptureDevice__ID,
    Msg_AllocateCaptureDevice__ID,
    Msg_ReleaseCaptureDevice__ID,
    Msg_StartCapture__ID,
    Msg_StopCapture__ID,
    Msg_ReleaseFrame__ID,
    Msg_AllDone__ID,
    Msg_EnsureInitialized__ID,
    PCamerasEnd
};

bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg_FrameSizeChange(int32_t routingId);

IPC::Message*
Msg_DeliverFrame(int32_t routingId);

IPC::Message*
Msg_DeviceChange(int32_t routingId);

IPC::Message*
Msg_ReplyNumberOfCaptureDevices(int32_t routingId);

IPC::Message*
Msg_ReplyNumberOfCapabilities(int32_t routingId);

IPC::Message*
Msg_ReplyAllocateCaptureDevice(int32_t routingId);

IPC::Message*
Msg_ReplyGetCaptureCapability(int32_t routingId);

IPC::Message*
Msg_ReplyGetCaptureDevice(int32_t routingId);

IPC::Message*
Msg_ReplyFailure(int32_t routingId);

IPC::Message*
Msg_ReplySuccess(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_NumberOfCaptureDevices(int32_t routingId);

IPC::Message*
Msg_NumberOfCapabilities(int32_t routingId);

IPC::Message*
Msg_GetCaptureCapability(int32_t routingId);

IPC::Message*
Msg_GetCaptureDevice(int32_t routingId);

IPC::Message*
Msg_AllocateCaptureDevice(int32_t routingId);

IPC::Message*
Msg_ReleaseCaptureDevice(int32_t routingId);

IPC::Message*
Msg_StartCapture(int32_t routingId);

IPC::Message*
Msg_StopCapture(int32_t routingId);

IPC::Message*
Msg_ReleaseFrame(int32_t routingId);

IPC::Message*
Msg_AllDone(int32_t routingId);

IPC::Message*
Msg_EnsureInitialized(int32_t routingId);



} // namespace PCameras
} // namespace camera
} // namespace mozilla

#endif // ifndef PCameras_h
