//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMessagePort_h
#define PMessagePort_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/dom/DOMTypes.h"

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class MessagePortIdentifier;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MessagePortMessage|
//
namespace mozilla {
namespace dom {
class MessagePortMessage final
{
private:
    typedef mozilla::SerializedStructuredCloneBuffer SerializedStructuredCloneBuffer;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef mozilla::dom::MessagePortIdentifier MessagePortIdentifier;

public:
    MOZ_IMPLICIT MessagePortMessage();

    MOZ_IMPLICIT MessagePortMessage(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild,
            const nsTArray<MessagePortIdentifier>& _transferredPorts)
    {
        Init();
        Assign(_data, _blobsParent, _blobsChild, _transferredPorts);
    }

    MOZ_IMPLICIT MessagePortMessage(const MessagePortMessage& _o)
    {
        Init();
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild(), (_o).transferredPorts());
    }

    ~MessagePortMessage();

    void
    operator=(const MessagePortMessage& _o)
    {
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild(), (_o).transferredPorts());
    }

    bool
    operator==(const MessagePortMessage& _o) const;

    SerializedStructuredCloneBuffer&
    data()
    {
        return data_;
    }
    const SerializedStructuredCloneBuffer&
    data() const
    {
        return data_;
    }

    nsTArray<PBlobParent*>&
    blobsParent()
    {
        return blobsParent_;
    }
    const nsTArray<PBlobParent*>&
    blobsParent() const
    {
        return blobsParent_;
    }

    nsTArray<PBlobChild*>&
    blobsChild()
    {
        return blobsChild_;
    }
    const nsTArray<PBlobChild*>&
    blobsChild() const
    {
        return blobsChild_;
    }

    nsTArray<MessagePortIdentifier>&
    transferredPorts()
    {
        return transferredPorts_;
    }
    const nsTArray<MessagePortIdentifier>&
    transferredPorts() const
    {
        return transferredPorts_;
    }

private:
    void
    Init();

    void
    Assign(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild,
            const nsTArray<MessagePortIdentifier>& _transferredPorts);

    SerializedStructuredCloneBuffer data_;
    nsTArray<PBlobParent*> blobsParent_;
    nsTArray<PBlobChild*> blobsChild_;
    nsTArray<MessagePortIdentifier> transferredPorts_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PMessagePortParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PMessagePortChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PMessagePortChild and PMessagePortParent
//
namespace mozilla {
namespace dom {
namespace PMessagePort {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PMessagePortParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PMessagePortChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PMessagePortStart = PMessagePortMsgStart << 16,
    Msg_PostMessages__ID,
    Msg_Disentangle__ID,
    Msg_StopSendingData__ID,
    Msg_Close__ID,
    Msg_Entangled__ID,
    Msg_ReceiveData__ID,
    Msg_StopSendingDataConfirmed__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PMessagePortEnd
};

bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg_PostMessages(int32_t routingId);

IPC::Message*
Msg_Disentangle(int32_t routingId);

IPC::Message*
Msg_StopSendingData(int32_t routingId);

IPC::Message*
Msg_Close(int32_t routingId);

IPC::Message*
Msg_Entangled(int32_t routingId);

IPC::Message*
Msg_ReceiveData(int32_t routingId);

IPC::Message*
Msg_StopSendingDataConfirmed(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PMessagePort
} // namespace dom
} // namespace mozilla

#endif // ifndef PMessagePort_h
