//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PScreenManager_h
#define PScreenManager_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "nsRect.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScreenDetails|
//
namespace mozilla {
namespace dom {
class ScreenDetails final
{
private:

public:
    MOZ_IMPLICIT ScreenDetails();

    MOZ_IMPLICIT ScreenDetails(
            const uint32_t& _id,
            const nsIntRect& _rect,
            const nsIntRect& _rectDisplayPix,
            const nsIntRect& _availRect,
            const nsIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const double& _contentsScaleFactor)
    {
        Init();
        Assign(_id, _rect, _rectDisplayPix, _availRect, _availRectDisplayPix, _pixelDepth, _colorDepth, _contentsScaleFactor);
    }

    MOZ_IMPLICIT ScreenDetails(const ScreenDetails& _o)
    {
        Init();
        Assign((_o).id(), (_o).rect(), (_o).rectDisplayPix(), (_o).availRect(), (_o).availRectDisplayPix(), (_o).pixelDepth(), (_o).colorDepth(), (_o).contentsScaleFactor());
    }

    ~ScreenDetails();

    void
    operator=(const ScreenDetails& _o)
    {
        Assign((_o).id(), (_o).rect(), (_o).rectDisplayPix(), (_o).availRect(), (_o).availRectDisplayPix(), (_o).pixelDepth(), (_o).colorDepth(), (_o).contentsScaleFactor());
    }

    bool
    operator==(const ScreenDetails& _o) const;

    uint32_t&
    id()
    {
        return id_;
    }
    const uint32_t&
    id() const
    {
        return id_;
    }

    nsIntRect&
    rect()
    {
        return rect_;
    }
    const nsIntRect&
    rect() const
    {
        return rect_;
    }

    nsIntRect&
    rectDisplayPix()
    {
        return rectDisplayPix_;
    }
    const nsIntRect&
    rectDisplayPix() const
    {
        return rectDisplayPix_;
    }

    nsIntRect&
    availRect()
    {
        return availRect_;
    }
    const nsIntRect&
    availRect() const
    {
        return availRect_;
    }

    nsIntRect&
    availRectDisplayPix()
    {
        return availRectDisplayPix_;
    }
    const nsIntRect&
    availRectDisplayPix() const
    {
        return availRectDisplayPix_;
    }

    int32_t&
    pixelDepth()
    {
        return pixelDepth_;
    }
    const int32_t&
    pixelDepth() const
    {
        return pixelDepth_;
    }

    int32_t&
    colorDepth()
    {
        return colorDepth_;
    }
    const int32_t&
    colorDepth() const
    {
        return colorDepth_;
    }

    double&
    contentsScaleFactor()
    {
        return contentsScaleFactor_;
    }
    const double&
    contentsScaleFactor() const
    {
        return contentsScaleFactor_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _id,
            const nsIntRect& _rect,
            const nsIntRect& _rectDisplayPix,
            const nsIntRect& _availRect,
            const nsIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const double& _contentsScaleFactor);

    uint32_t id_;
    nsIntRect rect_;
    nsIntRect rectDisplayPix_;
    nsIntRect availRect_;
    nsIntRect availRectDisplayPix_;
    int32_t pixelDepth_;
    int32_t colorDepth_;
    double contentsScaleFactor_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PScreenManagerParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PScreenManagerChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PScreenManagerChild and PScreenManagerParent
//
namespace mozilla {
namespace dom {
namespace PScreenManager {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PScreenManagerParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PScreenManagerChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PScreenManagerStart = PScreenManagerMsgStart << 16,
    Msg_Refresh__ID,
    Reply_Refresh__ID,
    Msg_ScreenRefresh__ID,
    Reply_ScreenRefresh__ID,
    Msg_GetPrimaryScreen__ID,
    Reply_GetPrimaryScreen__ID,
    Msg_ScreenForRect__ID,
    Reply_ScreenForRect__ID,
    Msg_ScreenForBrowser__ID,
    Reply_ScreenForBrowser__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PScreenManagerEnd
};

bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg_Refresh(int32_t routingId);
IPC::Message*
Reply_Refresh(int32_t routingId);

IPC::Message*
Msg_ScreenRefresh(int32_t routingId);
IPC::Message*
Reply_ScreenRefresh(int32_t routingId);

IPC::Message*
Msg_GetPrimaryScreen(int32_t routingId);
IPC::Message*
Reply_GetPrimaryScreen(int32_t routingId);

IPC::Message*
Msg_ScreenForRect(int32_t routingId);
IPC::Message*
Reply_ScreenForRect(int32_t routingId);

IPC::Message*
Msg_ScreenForBrowser(int32_t routingId);
IPC::Message*
Reply_ScreenForBrowser(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PScreenManager
} // namespace dom
} // namespace mozilla

#endif // ifndef PScreenManager_h
