//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPAudioDecoderParent_h
#define PGMPAudioDecoderParent_h

#include "mozilla/gmp/PGMPAudioDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-audio-codec.h"
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPAudioDecoderParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::gmp::PGMPContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPKeyInformation GMPKeyInformation;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;

    typedef PGMPAudioDecoder::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvDecoded(const GMPAudioDecodedSampleData& aDecoded) = 0;
    virtual bool
    RecvInputDataExhausted() = 0;
    virtual bool
    RecvDrainComplete() = 0;
    virtual bool
    RecvResetComplete() = 0;
    virtual bool
    RecvError(const GMPErr& aErr) = 0;
    virtual bool
    RecvShutdown() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PGMPAudioDecoderParent();

    virtual ~PGMPAudioDecoderParent();

    PGMPContentParent*
    Manager() const;

    PGMPAudioDecoder::State
    state();

    MOZ_MUST_USE bool
    SendInitDecode(const GMPAudioCodecData& aCodecSettings);

    MOZ_MUST_USE bool
    SendDecode(const GMPAudioEncodedSampleData& aInput);

    MOZ_MUST_USE bool
    SendReset();

    MOZ_MUST_USE bool
    SendDrain();

    MOZ_MUST_USE bool
    SendDecodingComplete();

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const GMPDecryptionData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPDecryptionData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPAudioEncodedSampleData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPAudioEncodedSampleData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PGMPAudioDecoderParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPAudioDecoderParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const GMPAudioDecodedSampleData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPAudioDecodedSampleData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPAudioCodecData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPAudioCodecData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPAudioDecoderParent :
    public PGMPAudioDecoderParent
{
    virtual bool
    RecvDecoded(const GMPAudioDecodedSampleData& aDecoded);

    virtual bool
    RecvInputDataExhausted();

    virtual bool
    RecvDrainComplete();

    virtual bool
    RecvResetComplete();

    virtual bool
    RecvError(const GMPErr& aErr);

    virtual bool
    RecvShutdown();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPAudioDecoderParent();
    virtual ~GMPAudioDecoderParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPAudioDecoderParent::RecvDecoded(const GMPAudioDecodedSampleData& aDecoded)
{
    return false;
}

bool
GMPAudioDecoderParent::RecvInputDataExhausted()
{
    return false;
}

bool
GMPAudioDecoderParent::RecvDrainComplete()
{
    return false;
}

bool
GMPAudioDecoderParent::RecvResetComplete()
{
    return false;
}

bool
GMPAudioDecoderParent::RecvError(const GMPErr& aErr)
{
    return false;
}

bool
GMPAudioDecoderParent::RecvShutdown()
{
    return false;
}

void
GMPAudioDecoderParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPAudioDecoderParent::GMPAudioDecoderParent()
{
    MOZ_COUNT_CTOR(GMPAudioDecoderParent);
}

MOZ_IMPLICIT GMPAudioDecoderParent::~GMPAudioDecoderParent()
{
    MOZ_COUNT_DTOR(GMPAudioDecoderParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPAudioDecoderParent_h
