//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPServiceParent_h
#define PGMPServiceParent_h

#include "mozilla/gmp/PGMPService.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

class nsIFile;

// Headers for things that cannot be forward declared
#include "base/process.h"

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPServiceParent :
    public mozilla::ipc::IToplevelProtocol
{
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPParent PGMPParent;
    typedef mozilla::gmp::PGMPChild PGMPChild;

    typedef PGMPService::State State;

    virtual bool
    RecvSelectGMP(
            const nsCString& nodeId,
            const nsCString& api,
            nsTArray<nsCString>&& tags,
            uint32_t* pluginId,
            nsresult* aResult) = 0;
    virtual bool
    RecvLaunchGMP(
            const uint32_t& pluginId,
            nsTArray<ProcessId>&& alreadyBridgedTo,
            ProcessId* id,
            nsCString* displayName,
            nsresult* aResult) = 0;
    virtual bool
    RecvGetGMPNodeId(
            const nsString& origin,
            const nsString& topLevelOrigin,
            const nsString& gmpName,
            const bool& inPrivateBrowsing,
            nsCString* id) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PGMPServiceParent();

    virtual ~PGMPServiceParent();

    PGMPService::State
    state();

    virtual MessageChannel*
    GetIPCChannel();
    virtual const MessageChannel*
    GetIPCChannel() const;
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

    void
    OnChannelClose();

    void
    OnChannelError();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPGMPServiceParent();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    Channel mChannel;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPServiceParent :
    public PGMPServiceParent
{
    virtual bool
    RecvSelectGMP(
            const nsCString& nodeId,
            const nsCString& api,
            nsTArray<nsCString>&& tags,
            uint32_t* pluginId,
            nsresult* aResult);

    virtual bool
    RecvLaunchGMP(
            const uint32_t& pluginId,
            nsTArray<ProcessId>&& alreadyBridgedTo,
            ProcessId* id,
            nsCString* displayName,
            nsresult* aResult);

    virtual bool
    RecvGetGMPNodeId(
            const nsString& origin,
            const nsString& topLevelOrigin,
            const nsString& gmpName,
            const bool& inPrivateBrowsing,
            nsCString* id);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPServiceParent();
    virtual ~GMPServiceParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPServiceParent::RecvSelectGMP(
        const nsCString& nodeId,
        const nsCString& api,
        nsTArray<nsCString>&& tags,
        uint32_t* pluginId,
        nsresult* aResult)
{
    return false;
}

bool
GMPServiceParent::RecvLaunchGMP(
        const uint32_t& pluginId,
        nsTArray<ProcessId>&& alreadyBridgedTo,
        ProcessId* id,
        nsCString* displayName,
        nsresult* aResult)
{
    return false;
}

bool
GMPServiceParent::RecvGetGMPNodeId(
        const nsString& origin,
        const nsString& topLevelOrigin,
        const nsString& gmpName,
        const bool& inPrivateBrowsing,
        nsCString* id)
{
    return false;
}

void
GMPServiceParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPServiceParent::GMPServiceParent()
{
    MOZ_COUNT_CTOR(GMPServiceParent);
}

MOZ_IMPLICIT GMPServiceParent::~GMPServiceParent()
{
    MOZ_COUNT_DTOR(GMPServiceParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPServiceParent_h
