//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoEncoderChild_h
#define PGMPVideoEncoderChild_h

#include "mozilla/gmp/PGMPVideoEncoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"
#include "gmp-video-frame-encoded.h"

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoEncoderChild :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::gmp::PGMPContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPKeyInformation GMPKeyInformation;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;

    typedef PGMPVideoEncoder::State State;

    virtual bool
    RecvInitEncode(
            const GMPVideoCodec& aCodecSettings,
            nsTArray<uint8_t>&& aCodecSpecific,
            const int32_t& aNumberOfCores,
            const uint32_t& aMaxPayloadSize) = 0;
    virtual bool
    RecvEncode(
            const GMPVideoi420FrameData& aInputFrame,
            nsTArray<uint8_t>&& aCodecSpecificInfo,
            nsTArray<GMPVideoFrameType>&& aFrameTypes) = 0;
    virtual bool
    RecvSetChannelParameters(
            const uint32_t& aPacketLoss,
            const uint32_t& aRTT) = 0;
    virtual bool
    RecvSetRates(
            const uint32_t& aNewBitRate,
            const uint32_t& aFrameRate) = 0;
    virtual bool
    RecvSetPeriodicKeyFrames(const bool& aEnable) = 0;
    virtual bool
    RecvEncodingComplete() = 0;
    virtual bool
    RecvChildShmemForPool(Shmem&& aEncodedBuffer) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PGMPVideoEncoderChild();

    virtual ~PGMPVideoEncoderChild();

    PGMPContentChild*
    Manager() const;

    PGMPVideoEncoder::State
    state();

    static bool
    Send__delete__(PGMPVideoEncoderChild* actor);

    bool
    SendEncoded(
            const GMPVideoEncodedFrameData& aEncodedFrame,
            const nsTArray<uint8_t>& aCodecSpecificInfo);

    bool
    SendError(const GMPErr& aErr);

    bool
    SendShutdown();

    bool
    SendParentShmemForPool(Shmem& aFrameBuffer);

    bool
    CallNeedShmem(
            const uint32_t& aEncodedBufferSize,
            Shmem* aMem);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const GMPDecryptionData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPDecryptionData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            Shmem* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPVideoi420FrameData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPVideoi420FrameData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PGMPVideoEncoderChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPVideoEncoderChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const GMPVideoEncodedFrameData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPVideoEncodedFrameData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPPlaneData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPPlaneData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPVideoEncoderChild :
    public PGMPVideoEncoderChild
{
    virtual bool
    RecvInitEncode(
            const GMPVideoCodec& aCodecSettings,
            nsTArray<uint8_t>&& aCodecSpecific,
            const int32_t& aNumberOfCores,
            const uint32_t& aMaxPayloadSize);

    virtual bool
    RecvEncode(
            const GMPVideoi420FrameData& aInputFrame,
            nsTArray<uint8_t>&& aCodecSpecificInfo,
            nsTArray<GMPVideoFrameType>&& aFrameTypes);

    virtual bool
    RecvSetChannelParameters(
            const uint32_t& aPacketLoss,
            const uint32_t& aRTT);

    virtual bool
    RecvSetRates(
            const uint32_t& aNewBitRate,
            const uint32_t& aFrameRate);

    virtual bool
    RecvSetPeriodicKeyFrames(const bool& aEnable);

    virtual bool
    RecvEncodingComplete();

    virtual bool
    RecvChildShmemForPool(Shmem&& aEncodedBuffer);

    MOZ_IMPLICIT GMPVideoEncoderChild();
    virtual ~GMPVideoEncoderChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPVideoEncoderChild::RecvInitEncode(
        const GMPVideoCodec& aCodecSettings,
        nsTArray<uint8_t>&& aCodecSpecific,
        const int32_t& aNumberOfCores,
        const uint32_t& aMaxPayloadSize)
{
    return false;
}

bool
GMPVideoEncoderChild::RecvEncode(
        const GMPVideoi420FrameData& aInputFrame,
        nsTArray<uint8_t>&& aCodecSpecificInfo,
        nsTArray<GMPVideoFrameType>&& aFrameTypes)
{
    return false;
}

bool
GMPVideoEncoderChild::RecvSetChannelParameters(
        const uint32_t& aPacketLoss,
        const uint32_t& aRTT)
{
    return false;
}

bool
GMPVideoEncoderChild::RecvSetRates(
        const uint32_t& aNewBitRate,
        const uint32_t& aFrameRate)
{
    return false;
}

bool
GMPVideoEncoderChild::RecvSetPeriodicKeyFrames(const bool& aEnable)
{
    return false;
}

bool
GMPVideoEncoderChild::RecvEncodingComplete()
{
    return false;
}

bool
GMPVideoEncoderChild::RecvChildShmemForPool(Shmem&& aEncodedBuffer)
{
    return false;
}

MOZ_IMPLICIT GMPVideoEncoderChild::GMPVideoEncoderChild()
{
    MOZ_COUNT_CTOR(GMPVideoEncoderChild);
}

MOZ_IMPLICIT GMPVideoEncoderChild::~GMPVideoEncoderChild()
{
    MOZ_COUNT_DTOR(GMPVideoEncoderChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPVideoEncoderChild_h
