//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PLayerTransaction_h
#define PLayerTransaction_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/layers/LayersSurfaces.h"
#include "mozilla/layers/LayersMessages.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeTransform|
//
namespace mozilla {
namespace layers {
class MaybeTransform final
{
public:
    enum Type {
        T__None,
        TMatrix4x4 = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef mozilla::void_t void_t;
    typedef Matrix4x4 Matrix4x4__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<Matrix4x4> VMatrix4x4;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    Matrix4x4*
    ptr_Matrix4x4()
    {
        return ((mValue).VMatrix4x4).addr();
    }
    const Matrix4x4*
    constptr_Matrix4x4() const
    {
        return ((mValue).VMatrix4x4).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeTransform() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeTransform(const Matrix4x4& aOther);

    MOZ_IMPLICIT MaybeTransform(const void_t& aOther);

    MOZ_IMPLICIT MaybeTransform(const MaybeTransform& aOther);

    ~MaybeTransform();

    Type
    type() const
    {
        return mType;
    }

    MaybeTransform&
    operator=(const Matrix4x4& aRhs);

    MaybeTransform&
    operator=(const void_t& aRhs);

    MaybeTransform&
    operator=(const MaybeTransform& aRhs);

    bool
    operator==(const Matrix4x4& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const MaybeTransform& aRhs) const;

    Matrix4x4&
    get_Matrix4x4()
    {
        AssertSanity(TMatrix4x4);
        return (*(ptr_Matrix4x4()));
    }
    const Matrix4x4&
    get_Matrix4x4() const
    {
        AssertSanity(TMatrix4x4);
        return (*(constptr_Matrix4x4()));
    }
    void
    get(Matrix4x4* aOutValue) const;
    operator Matrix4x4&()
    {
        return get_Matrix4x4();
    }
    operator const Matrix4x4&() const
    {
        return get_Matrix4x4();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerTransactionParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PLayerTransactionChild;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PLayerTransactionChild and PLayerTransactionParent
//
namespace mozilla {
namespace layers {
namespace PLayerTransaction {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::layers::PLayerTransactionParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::layers::PLayerTransactionChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PLayerTransactionStart = PLayerTransactionMsgStart << 16,
    Msg_PLayerConstructor__ID,
    Reply_PLayerConstructor__ID,
    Msg_PCompositableConstructor__ID,
    Reply_PCompositableConstructor__ID,
    Msg_Update__ID,
    Reply_Update__ID,
    Msg_PaintTime__ID,
    Msg_UpdateNoSwap__ID,
    Msg_SetLayerObserverEpoch__ID,
    Msg_SetTestSampleTime__ID,
    Reply_SetTestSampleTime__ID,
    Msg_LeaveTestMode__ID,
    Reply_LeaveTestMode__ID,
    Msg_GetAnimationOpacity__ID,
    Reply_GetAnimationOpacity__ID,
    Msg_GetAnimationTransform__ID,
    Reply_GetAnimationTransform__ID,
    Msg_SetAsyncScrollOffset__ID,
    Reply_SetAsyncScrollOffset__ID,
    Msg_SetAsyncZoom__ID,
    Reply_SetAsyncZoom__ID,
    Msg_FlushApzRepaints__ID,
    Msg_ClearCachedResources__ID,
    Msg_ForceComposite__ID,
    Msg_GetAPZTestData__ID,
    Reply_GetAPZTestData__ID,
    Msg_RequestProperty__ID,
    Reply_RequestProperty__ID,
    Msg_SetConfirmedTargetAPZC__ID,
    Msg_Shutdown__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PLayerTransactionEnd
};

bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg_PLayerConstructor(int32_t routingId);
IPC::Message*
Reply_PLayerConstructor(int32_t routingId);

IPC::Message*
Msg_PCompositableConstructor(int32_t routingId);
IPC::Message*
Reply_PCompositableConstructor(int32_t routingId);

IPC::Message*
Msg_Update(int32_t routingId);
IPC::Message*
Reply_Update(int32_t routingId);

IPC::Message*
Msg_PaintTime(int32_t routingId);

IPC::Message*
Msg_UpdateNoSwap(int32_t routingId);

IPC::Message*
Msg_SetLayerObserverEpoch(int32_t routingId);

IPC::Message*
Msg_SetTestSampleTime(int32_t routingId);
IPC::Message*
Reply_SetTestSampleTime(int32_t routingId);

IPC::Message*
Msg_LeaveTestMode(int32_t routingId);
IPC::Message*
Reply_LeaveTestMode(int32_t routingId);

IPC::Message*
Msg_GetAnimationOpacity(int32_t routingId);
IPC::Message*
Reply_GetAnimationOpacity(int32_t routingId);

IPC::Message*
Msg_GetAnimationTransform(int32_t routingId);
IPC::Message*
Reply_GetAnimationTransform(int32_t routingId);

IPC::Message*
Msg_SetAsyncScrollOffset(int32_t routingId);
IPC::Message*
Reply_SetAsyncScrollOffset(int32_t routingId);

IPC::Message*
Msg_SetAsyncZoom(int32_t routingId);
IPC::Message*
Reply_SetAsyncZoom(int32_t routingId);

IPC::Message*
Msg_FlushApzRepaints(int32_t routingId);

IPC::Message*
Msg_ClearCachedResources(int32_t routingId);

IPC::Message*
Msg_ForceComposite(int32_t routingId);

IPC::Message*
Msg_GetAPZTestData(int32_t routingId);
IPC::Message*
Reply_GetAPZTestData(int32_t routingId);

IPC::Message*
Msg_RequestProperty(int32_t routingId);
IPC::Message*
Reply_RequestProperty(int32_t routingId);

IPC::Message*
Msg_SetConfirmedTargetAPZC(int32_t routingId);

IPC::Message*
Msg_Shutdown(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PLayerTransaction
} // namespace layers
} // namespace mozilla

#endif // ifndef PLayerTransaction_h
