/* This file is auto-generated, only for internal use in TelemetryEvent.h,
   see gen-event-data.py. */

#ifndef mozilla_TelemetryEventData_h
#define mozilla_TelemetryEventData_h
#include "EventInfo.h"
namespace {

const uint32_t gExtraKeysTable[] = {
  // navigation, [search], [about_home, about_newtab, contextmenu, oneoff, suggestion, alias, enter, searchbar, urlbar]
  // extra_keys: engine
  0,
  // telemetry.test, [test1, test2], [object1, object2]
  // extra_keys: key2, key1
  7, 12,
  // telemetry.test, [optout], [object1, object2]
  // extra_keys: key1
  12,
  // telemetry.test.second, [test], [object1, object2, object3]
  // extra_keys: key1
  12,
};
static_assert(sizeof(gExtraKeysTable) <= UINT32_MAX, "index overflow");

const CommonEventInfo gCommonEventInfo[] = {
  // category: navigation
  // methods: [search]
  // objects: [about_home, about_newtab, contextmenu, oneoff, suggestion, alias, enter, searchbar, urlbar]
  {17, 28, 0, 1, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN},
  // category: telemetry.test
  // methods: [test1, test2]
  // objects: [object1, object2]
  {35, 50, 1, 2, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN},
  // category: telemetry.test
  // methods: [optout]
  // objects: [object1, object2]
  {35, 50, 3, 1, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTOUT},
  // category: telemetry.test
  // methods: [expired_version]
  // objects: [object1, object2]
  {35, 56, 0, 0, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN},
  // category: telemetry.test
  // methods: [expired_date]
  // objects: [object1, object2]
  {35, 50, 0, 0, 16098, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN},
  // category: telemetry.test
  // methods: [not_expired_optout]
  // objects: [object1]
  {35, 60, 0, 0, 47117, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTOUT},
  // category: telemetry.test.second
  // methods: [test]
  // objects: [object1, object2, object3]
  {68, 50, 4, 1, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN},
};
static_assert(sizeof(gCommonEventInfo) <= UINT32_MAX, "index overflow");

const EventInfo gEventInfo[] = {
  // category: navigation, method: search, object: about_home
  {gCommonEventInfo[0], 90, 97},
  // category: navigation, method: search, object: about_newtab
  {gCommonEventInfo[0], 90, 108},
  // category: navigation, method: search, object: contextmenu
  {gCommonEventInfo[0], 90, 121},
  // category: navigation, method: search, object: oneoff
  {gCommonEventInfo[0], 90, 133},
  // category: navigation, method: search, object: suggestion
  {gCommonEventInfo[0], 90, 140},
  // category: navigation, method: search, object: alias
  {gCommonEventInfo[0], 90, 151},
  // category: navigation, method: search, object: enter
  {gCommonEventInfo[0], 90, 157},
  // category: navigation, method: search, object: searchbar
  {gCommonEventInfo[0], 90, 163},
  // category: navigation, method: search, object: urlbar
  {gCommonEventInfo[0], 90, 173},
  // category: telemetry.test, method: test1, object: object1
  {gCommonEventInfo[1], 180, 186},
  // category: telemetry.test, method: test1, object: object2
  {gCommonEventInfo[1], 180, 194},
  // category: telemetry.test, method: test2, object: object1
  {gCommonEventInfo[1], 202, 186},
  // category: telemetry.test, method: test2, object: object2
  {gCommonEventInfo[1], 202, 194},
  // category: telemetry.test, method: optout, object: object1
  {gCommonEventInfo[2], 208, 186},
  // category: telemetry.test, method: optout, object: object2
  {gCommonEventInfo[2], 208, 194},
  // category: telemetry.test, method: expired_version, object: object1
  {gCommonEventInfo[3], 215, 186},
  // category: telemetry.test, method: expired_version, object: object2
  {gCommonEventInfo[3], 215, 194},
  // category: telemetry.test, method: expired_date, object: object1
  {gCommonEventInfo[4], 231, 186},
  // category: telemetry.test, method: expired_date, object: object2
  {gCommonEventInfo[4], 231, 194},
  // category: telemetry.test, method: not_expired_optout, object: object1
  {gCommonEventInfo[5], 244, 186},
  // category: telemetry.test.second, method: test, object: object1
  {gCommonEventInfo[6], 263, 186},
  // category: telemetry.test.second, method: test, object: object2
  {gCommonEventInfo[6], 263, 194},
  // category: telemetry.test.second, method: test, object: object3
  {gCommonEventInfo[6], 263, 268},
};
static_assert(sizeof(gEventInfo) <= UINT32_MAX, "index overflow");

const char gEventsStringTable[] = {
  /*     0 - "engine" */ 'e', 'n', 'g', 'i', 'n', 'e', '\0',
  /*     7 - "key2" */ 'k', 'e', 'y', '2', '\0',
  /*    12 - "key1" */ 'k', 'e', 'y', '1', '\0',
  /*    17 - "navigation" */ 'n', 'a', 'v', 'i', 'g', 'a', 't', 'i', 'o', 'n', '\0',
  /*    28 - "58.0a1" */ '5', '8', '.', '0', 'a', '1', '\0',
  /*    35 - "telemetry.test" */ 't', 'e', 'l', 'e', 'm', 'e', 't', 'r', 'y', '.', 't', 'e', 's', 't', '\0',
  /*    50 - "never" */ 'n', 'e', 'v', 'e', 'r', '\0',
  /*    56 - "3.6" */ '3', '.', '6', '\0',
  /*    60 - "999.0a1" */ '9', '9', '9', '.', '0', 'a', '1', '\0',
  /*    68 - "telemetry.test.second" */ 't', 'e', 'l', 'e', 'm', 'e', 't', 'r', 'y', '.', 't', 'e', 's', 't', '.', 's', 'e', 'c', 'o', 'n', 'd', '\0',
  /*    90 - "search" */ 's', 'e', 'a', 'r', 'c', 'h', '\0',
  /*    97 - "about_home" */ 'a', 'b', 'o', 'u', 't', '_', 'h', 'o', 'm', 'e', '\0',
  /*   108 - "about_newtab" */ 'a', 'b', 'o', 'u', 't', '_', 'n', 'e', 'w', 't', 'a', 'b', '\0',
  /*   121 - "contextmenu" */ 'c', 'o', 'n', 't', 'e', 'x', 't', 'm', 'e', 'n', 'u', '\0',
  /*   133 - "oneoff" */ 'o', 'n', 'e', 'o', 'f', 'f', '\0',
  /*   140 - "suggestion" */ 's', 'u', 'g', 'g', 'e', 's', 't', 'i', 'o', 'n', '\0',
  /*   151 - "alias" */ 'a', 'l', 'i', 'a', 's', '\0',
  /*   157 - "enter" */ 'e', 'n', 't', 'e', 'r', '\0',
  /*   163 - "searchbar" */ 's', 'e', 'a', 'r', 'c', 'h', 'b', 'a', 'r', '\0',
  /*   173 - "urlbar" */ 'u', 'r', 'l', 'b', 'a', 'r', '\0',
  /*   180 - "test1" */ 't', 'e', 's', 't', '1', '\0',
  /*   186 - "object1" */ 'o', 'b', 'j', 'e', 'c', 't', '1', '\0',
  /*   194 - "object2" */ 'o', 'b', 'j', 'e', 'c', 't', '2', '\0',
  /*   202 - "test2" */ 't', 'e', 's', 't', '2', '\0',
  /*   208 - "optout" */ 'o', 'p', 't', 'o', 'u', 't', '\0',
  /*   215 - "expired_version" */ 'e', 'x', 'p', 'i', 'r', 'e', 'd', '_', 'v', 'e', 'r', 's', 'i', 'o', 'n', '\0',
  /*   231 - "expired_date" */ 'e', 'x', 'p', 'i', 'r', 'e', 'd', '_', 'd', 'a', 't', 'e', '\0',
  /*   244 - "not_expired_optout" */ 'n', 'o', 't', '_', 'e', 'x', 'p', 'i', 'r', 'e', 'd', '_', 'o', 'p', 't', 'o', 'u', 't', '\0',
  /*   263 - "test" */ 't', 'e', 's', 't', '\0',
  /*   268 - "object3" */ 'o', 'b', 'j', 'e', 'c', 't', '3', '\0',
};

static_assert(sizeof(gEventsStringTable) <= UINT32_MAX, "index overflow");

} // namespace
#endif // mozilla_TelemetryEventData_h

